package net.wanji.opt.servicev2.syslog.impl;

import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import net.wanji.opt.dao.mapper.judgeanalysis.AnalysisProblemCrossDayMapper;
import net.wanji.opt.dao.mapper.syslog.SysLogMapper;
import net.wanji.opt.entity.comprehensivequery.CrossLaneDataHistPoExtendName;
import net.wanji.opt.entity.judgeanalysis.AnalysisProblemCrossDay;
import net.wanji.opt.entity.syslog.SysOptimizeLog;
import net.wanji.opt.servicev2.syslog.SysLogServer;
import org.apache.commons.collections.CollectionUtils;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.List;
import java.util.stream.Collectors;

/**
 * <p>
 * 系统日志
 * </p>
 *
 * @author huangwm
 * @since 2025-03-26
 */
@Service
public class SysLogServerImpl extends ServiceImpl<SysLogMapper, SysOptimizeLog> implements SysLogServer {
    @Resource
    private SysLogMapper sysLogMapper;

    @Override
    public JSONObject findSysOptimizeLog(String crossId,String startTime,String endTime,Integer pageNum,Integer pageSize) {
        List<SysOptimizeLog> list = sysLogMapper.findSysOptimizeLog(crossId,startTime,endTime);
        List<SysOptimizeLog> results =  new ArrayList<>();
        for(SysOptimizeLog temp : list){
            switch (temp.getCommandType()) {
                case "1":
                    JSONObject temp1 = JSONObject.parseObject(temp.getDataInfo());
                    if (temp1.get("command").equals(1)) {
                        temp.setCommandType("步进控制");
                    } else if (temp1.get("command").equals(0)) {
                        temp.setCommandType("步进恢复");
                    }
                    break;
                case "2":
                    temp.setCommandType("恢复时间表");
                    break;
                case "3":
                    JSONObject temp2 = JSONObject.parseObject(temp.getDataInfo());
                    if (temp2.get("command").equals(1)) {
                        temp.setCommandType("相位锁定");
                    } else if (temp2.get("command").equals(0)) {
                        temp.setCommandType("相位解锁");
                    }
                    break;
                case "4":
                    temp.setCommandType("临时方案下发");
                    break;
                case "5":
                    temp.setCommandType("定时任务恢复失败");
                    break;
                default:
                    temp.setCommandType("其它操作");
                    break;
            }
            results.add(temp);
        }
        List<SysOptimizeLog> collect = new ArrayList<>();
        if(CollectionUtils.isNotEmpty(results)){
            collect = results.stream().skip((pageNum - 1) * pageSize).limit(pageSize).collect(Collectors.toList());
        }
        JSONObject result = new JSONObject();
        result.put("fullDataList",results);
        result.put("pageList",collect);
        result.put("totalPage",Math.ceil((double) results.size() / pageSize));
        result.put("totalSize",results.size());
        return result;
    }
}
